#!/usr/bin/perl

##########################  SRCHARTPAGE.CGI ##############################
#
#
#   V2.1.7 Single User
#
#   utility that displays a chart generated by the charting app
#
#   Author : Michel G Delory
#   Created:  April 1996
#   Last Rev: Nov 29 1997
#
#

########################### ARRAYS & STRINGS ################################

$httpHeader = "Content-type: text/html\n\n";
$errorHeader = "<HTML><HEAD><TITLE>SurfReport Error</TITLE></HEAD>";
$htmlLine = "<P>\n<HR WIDTH = 80%>\n";  

$htmlTitleH = "<P><FONT SIZE = +2>";
$htmlTitleT = "</FONT><BR><PRE>\n";
$htmlEndReport = "</PRE>".$htmlLine;

############################## ENVIRONMENT ##################################

if (!defined ($ENV{SURFREPORT_CONFIG}) ||
    !defined ($ENV{SURFREPORT_LIB}))
{
    #V2.0B7
    #can't acces config file, let's go

    $err = "SurfReport environment is not available.\n";
    $err .= "Can't access your configuration file\n";
    $err .= "You must run this script through the SurfReport dispatcher\n";

    print $httpHeader;
    print $errorHeader;
    &FatalError ($err);

    exit (-1);

}

require $ENV{SURFREPORT_CONFIG};
require $ENV{SURFREPORT_LIB};

#get the base path for all SR output files
#and make sure all needed env vars are available
if (!defined ($ENV{SURFREPORT_OUT}) ||
    !defined ($ENV{SURFREPORT_HOME}) ||
    !defined ($ENV{DISPATCHER_URL}) )
{
    # exit now if env vars not available
    $err = "SurfReport environment is not available.\n";
    $err .= "You must run this script through the SurfReport dispatcher\n";

    print $httpHeader;
    print $errorHeader;
    &FatalError ($err);

    exit (-1);

}

#get command line arguments
$nameBase = $ARGV[0];
$setFile = $ARGV[1];
$gifFile = $ARGV[2];


#build gif URL
$gifURL = $srOutURL . "gifs/";
# complete URL with gif file name
$gifURL .= $gifFile;
   
#output HTML page
print $httpHeader;
$htmlBuf = &ReportHeader("SurfReport Charts");
$htmlBuf .= "<CENTER><IMG SRC=\"";
$htmlBuf .= $gifURL;
$htmlBuf .= "\"></CENTER>";

#path to the main dispatcher, will be called to fetch the chart design application 
$designPath = $ENV{DISPATCHER_URL};
$designPath .= "/design/$nameBase/$setFile";

$htmlBuf .= "<P><A HREF=\"$designPath\">[Modify Chart]</A> ";

#path pointing back to the report
$reportURL = $srOutURL . $nameBase . ".html";
$htmlBuf .= "<A HREF=\"$reportURL\">[Back to Report]</A> ";
$htmlBuf .= &InterfaceLink();
$htmlBuf .= "<P>\n";

#end with credits
$htmlBuf .= &PrintHTMLEnd();  

print $htmlBuf;

############################### SUBROUTINES ##################################

#
# display an error message on the web
#
sub FatalError
{
    local ($err) = @_;
    
    print "<body BGCOLOR = #FFFFFF TEXT = #OOOOOO >\n";
    print "<H3>Chart Display Error</H3>\n";
    

    print "<pre>\n\n";
    print $err;
    print "\n\n</pre>";

    print &PrintHTMLEnd();
}


#
# print end of page credits 
#
sub PrintHTMLEnd
{
	local ($htmlBuf);
	
    $htmlBuf = "<H5>SurfReport 2.1.7<br>";
	$htmlBuf .= "Copyright &copy; 1996, 1997 ";
	$htmlBuf .= "<A HREF = \"http://www.bienlogic.com\">";
	$htmlBuf .= "Bien Logic, Inc.</A></H5>\n";
	$htmlBuf .= "</BODY></HTML>";
	
	return $htmlBuf;
}




