#!/usr/bin/perl



################################ SRCONFIG #####################################
#
# V 2.1.7 Single User
#
# Generate an html FORM for configuring SR on the Web 
#  
#
# Author : Michel G. Delory
# created: July 1996
# last rev: Dec 12 1997
# 
# 
# copyright 1996, 1997 BienLogic Inc.
#
########################### ARRAYS & STRINGS ################################

$httpHeader = "Content-type: text/html\n\n";
$htmlLine = "<P>\n<HR WIDTH = 80%>\n";  
$errorHeader = "<HTML><HEAD><TITLE>SurfReport configuration error</TITLE></HEAD>";


$links = "<BR>";
$links .= "<A HREF = \"#paths\">[Paths]</A>";
$links .= "<A HREF = \"#server\">[Server]</A>";
$links .= "<A HREF = \"#urls\">[URLs]</A>";
$links .= "<BR>";

############################## ENVIRONMENT ##################################


#get the base path for all SR output files
#and make sure all needed env vars are available
if (!defined ($ENV{SURFREPORT_OUT}) ||
    !defined ($ENV{SURFREPORT_WEBHOME}) ||
    !defined ($ENV{SURFREPORT_HOME}) ||
    !defined ($ENV{DISPATCHER_URL}) ||
    !defined ($ENV{SURFREPORT_CONFIG}) ||
    !defined ($ENV{SURFREPORT_LIB}) ||
    !defined ($platform = $ENV{PLATFORM}))
{
    # exit now if env vars not available
    $err = "SurfReport environment is not available.\n";
    $err .= "You must run this script through the SurfReport dispatcher\n";

    print $httpHeader;
    print $errorHeader;
    &FatalError ($err);

    exit (-1);

}

################################# STATES  ##################################

### check cgi folder perms

#get configuration file name and deduce its folder
$configFile = $ENV{SURFREPORT_CONFIG};
$configFolder = substr ($configFile, 0, rindex ($configFile, "/") + 1);

# properties file always in main config folder
$propertyFile = $ENV{SURFREPORT_HOME} . "config/properties.cgi";

if (! -r $configFolder || ! -w $configFolder)
{
    $error = "SurfReport online configuration requires your configuration folder ";
    $error .= "to have temporary\nread/write permissions\n";
    $error .= "Your can and should restore your normal permissions after ";
    $error .= "SurfReport is properly configured";
    $error .= "\n$configFolder";
	   
    print $httpHeader;
    print $errorHeader;
    
    &FatalError ($error);
    exit (0);
}

# get lib file
# where we will keep a copy of the dispatcher's URL
$libFile = $ENV{SURFREPORT_LIB};
$libFolder = substr ($libFile, 0, rindex ($libFile, "/") + 1);

#the full name of the dispatcher script plus redirection to this script
$dispatcher = $ENV{DISPATCHER_URL};

$this.= $dispatcher . "/config";

if ($ENV{SERVER_NAME})
{
    $serverName = $ENV{SERVER_NAME};
    $serverName =~ s/\s*$//;
    if (defined ($serverPort = $ENV{SERVER_PORT}))
    {
	$serverPort =~ s/\s*$//;    
    }
}
else
{
    $serverName = "";
}

## this cgi's behavior depends on
## the state received on the env. query string
## or the state received as a value to the submit button
%Form = ();

if ($ENV{REQUEST_METHOD} eq POST)
{
    if (($error = &GetFormInput()) ne "")
    {
	print $httpHeader;
	print $errorHeader;
	&FatalError ($error);
	exit (0);
    }
    
}

#fetch state and optional arguments from the path info
#path info comes in unchanged from dispatcher
$command = $ENV{PATH_INFO};
$command =~ s/^\///;
$dummy = "";
($dummy, $state, $arg) = split ('\/', $command);

if ($state ne "form")
{
    # the 'form' state will redirect the output
    # to the interface form and needs a different header

    print $httpHeader;
    print "<HTML><HEAD><TITLE>SurfReport configuration</TITLE></HEAD>";
}

# holds perl variables values from config file
%Vars = ();
# holds values from property sheet
%Properties = ();
# holds the replacement list (new values for the variables)
%RepList = ();
$haveServerAlias = 0;

# update config file with user settings
# from the srconfig.cgi form
if ($state eq "update")
{
    # update the property sheet
    $error = &UpdateProperties ($propertyFile, *Properties, %Form);
    if ($error)
    {
	&FatalError ($error);
	exit (0);
    }

    # update the dispatcher URL in the common lib file
    # don't include any user name at this point
    $RepList{'$dispatcherURL'} = "\"". $ENV{DISPATCHER_URL} ."\"";
    
    $inFile = $libFile;
    $outFile = $libFolder. "srlib.tmp";

    $error = &UpdateConfigVars ($outFile, $inFile, *Vars, %RepList);
    if ($error)
    {
	&FatalError ($error);
	exit (0);
    }    

    # update user's config file
    &MakeRepList (*RepList, %Form);

    # checkboxes
    # if the box is unchecked when the form is submitted
    # there will be no entry for it in the %RepList array
    if (defined ($RepList{'$xHeadReq'}))
    {
	$RepList{'$xHeadReq'} = 1;
    }
    else
    {
	$RepList{'$xHeadReq'} = 0;
    }
    
    $inFile = $configFile;
    $outFile = $configFolder. "config.tmp";

    # will tell us not to find out 
    # settings automatically but to read the ones
    # already in the config file
    $RepList{'$configured'} = 1;

    $error = &UpdateConfigVars ($outFile, $inFile, *Vars, %RepList);
    if ($error)
    {
	&FatalError ($error);
	exit (0);
    }
  
    
    $action = "update";
}
else
{
    # state is not update,  
    # open and read configuration file
    # fetch variables/values in the %Vars array
    if (($error = &GetConfigVars ($configFile, *Vars)) ne "")
    {
	if ($state eq "form")
	{
	    print $httpHeader;
	    print $errorHeader;
	}
	&FatalError ($error);
	exit (0);	
    }
    if (($error = &GetProperties ($propertyFile, *Properties)) ne "")
    {
	if ($state eq "form")
	{
	    print $httpHeader;
	    print $errorHeader;
	}
	&FatalError ($error);
	exit (0);	
    }
    
    $action = "start"; 
}
   
if ($state eq "form")
{
    
    #build a full path name for the form interface
    $inFile = $ENV{SURFREPORT_WEBHOME}. "surfreport.html";

    # make a pid based temp file
    $tmp = $$ . ".html";
   
    #build a full path name for output file (copy of form interface where changes are made)
    $outFile = $ENV{SURFREPORT_WEBHOME} . $tmp;

	#build a URL for temporary form
    $tmpFormURL = &ExpandVal ($Vars{'$srURL'});
    $tmpFormURL .= $tmp;
       
    
    # change the form behavior
    # it will now point to this cgi
    %RepList = ( "ACTION", "$this/formDefaults/$tmp",
		 "SUBMIT", " Make Default ",
		 "RESET", " Reset Form ",
	       );

    %FormVars = ();

    $error = &UpdateFormVars ($inFile, $outFile, *FormVars, %RepList); 
    if ($error ne "")
    {
	print $httpHeader;
	print $errorHeader;
	&FatalError ($error);
    }
    else
    {
	# serve the "Make Default" form
	$htmlBuf = "Location: ";
	$htmlBuf .= $tmpFormURL;
	$htmlBuf .= "\n\n";

	print $htmlBuf;
    }

    # nothing else to do...
    exit (0);

}
elsif ($state eq "formDefaults")
{
   
     %RepList = ();
    %FormVars = ();

	# set the form configured flag
    $inFile = $configFile;
    $outFile = $configFolder. "config.tmp";

    $RepList{'$formConfigured'} = 1;

    $error = &UpdateConfigVars ($outFile, $inFile, *FormVars, %RepList);
    if ($error)
    {
		&FatalError ($error);
		exit (0);
    }

	%RepList = ();
    %FormVars = ();

	#update defaults of original form
   	#based on parameters coming from the form copy
   	
    #get full path name of the form copy
    $inFile = $ENV{SURFREPORT_WEBHOME};
    $inFile .= $arg;

	#get full path of original form
	$outFile = $ENV{SURFREPORT_WEBHOME}. "surfreport.html";
    # read current form variables
    # this will give us a reference so we can include names 
    # of unchecked checkboxes in the replacement list
    # we pass an empty string as an outFile name

    $error = &UpdateFormVars ($inFile, "", *FormVars, %RepList); 
    if ($error ne "")
    {
		&FatalError ($error);
		exit (0);
    }

    # make a replacement list, make sure even unchecked boxes
    # are listed
    %RepList = ();
    &MakeFormRepList (*RepList, %FormVars);

    # restore correct behavior of interface form
    # will now point to the dispatcher with 
    # user name (if multiuser) and launch as action
    $RepList{ACTION} = $dispatcher . "/launch";
    $RepList{SUBMIT} = " Launch SurfReport ";
    $RepList{RESET} = " Reset Defaults ";
    $RepList{MENU} = $dispatcher . "/menu";
 

    # update defaults in the real interface form
    $error = &UpdateFormVars($inFile, $outFile, *FormVars, %RepList);
        
    if ($error ne "")
    {
		&FatalError ($error);
		exit (0);
    }
       
    # get rid of temporary form copy
    unlink ($inFile);

	

    $action = "form";

}
elsif ($state eq "serverAlias")
{

	#saves current directory
	$curDir = `pwd`;
	chop ($curDir);
	
    # find root web directory 
    # assumes surfreport has been installed at the web root level
    # so just goes one level up from the SR home directory
    $dir = $ENV{SURFREPORT_WEBHOME};
    chop ($dir);
    $dir = substr ($dir, 0, rindex ($dir, "/"));
    
    if (!chdir ($dir))
    {
	$error = "Can't cd to Web Root directory '$dir'. $!";
	&FatalError( $error);
	exit (0);
    }

    # get list of existing aliases
    %Aliases = ();
    &GetAliases ($Vars{'%Aliases'}, *Aliases);

    # get a list of aliases
    %ServerAliases = ();
    $numServerAlias = 0;
    
    &GetLinks ('.');
    
    if (!chdir ($curDir))
    {
	$error = "Can't cd back to cgi-bin directory '$dir'. $!";
	&FatalError( $error);
	exit (0);
    }
    $haveServerAlias = 1;
    $action = "alias";

}


if ($state eq "reset")
{
    $configured = 0;
    $action = "reset";
}
elsif ($state eq "file")
{
    $configured = 1;
    $action = "file";
}
else
{
  # fetch default settings if flag is 0
  # read current settings if flag is 1
  $configured = $Vars{'$configured'};

}

# don't show the try surfreport link
# when the form is not configured
$formConfigured = $Vars{'$formConfigured'};

# get same colors as the ones in the config file, but no images yet
# we don't know the paths are right and we don't want to show a 
# broken link when we first start SR

$htmlBuf = "<BODY ";
$htmlBuf .= " BGCOLOR = $Vars{'$bgColor'}";
$htmlBuf .= " TEXT = $Vars{'$textColor'}";
$htmlBuf .= " LINK = $Vars{'$linkColor'}";
$htmlBuf .= " VLINK = $Vars{'$vlinkColor'}>\n";

print $htmlBuf;



######  title ###########
$htmlBuf = "<CENTER><p>";
$htmlBuf .= &Title(1, "SurfReport configuration");

$htmlBuf .= "</CENTER>\n";
$htmlBuf .= $htmlLine;

print $htmlBuf;

######################## REPORT  ##########################


if ($action eq "form")
{
 
    
    $formURL = &ExpandVal ($Vars{'$surfHtmlURL'});
    
    $htmlBuf = "<br><b>SurfReport</b> has changed the defaults in your ";
    $htmlBuf .= "interface form\n<br>Now, you can:";
    $htmlBuf .= "<UL>\n";
    $htmlBuf .= "<LI><A HREF=\"$formURL\">";
    $htmlBuf .= "Try SurfReport</a></LI>\n";
    $htmlBuf .= "<LI><A HREF=\"$this/form\">";
    $htmlBuf .= "Make more changes to the form</a></LI>\n";
    $htmlBuf .= "<LI><A HREF=\"$this/file\">";
    $htmlBuf .= "Make more changes to your configuration</a></LI>\n";
    $htmlBuf .= "</UL>\n";

    $htmlBuf .= $htmlLine;
    print $htmlBuf;
    
    &PrintHTMLEnd();

    exit (0);
}


if ($action eq "start")
{
   
    $htmlBuf = "<P>\n";
    if ($configured == 0)
    {
	$htmlBuf .= "<b>SurfReport</b> tried to find the best ";
	$htmlBuf .= "configuration settings for your machine\n<br>";
    }
    else
    {
	$htmlBuf .= "<b>SurfReport</b> is now showing ";
	$htmlBuf .= "your current configuration<br>";
    }

    $htmlBuf .= "<br>Please take a moment to\n";
    $htmlBuf .= "<UL>\n";
    $htmlBuf .= "<LI>Review each path and URL</LI>\n";
    if ($configured == 0)
    {
	$htmlBuf .= "<LI>Correct any error you find</LI>\n";
    }
    else
    {
	$htmlBuf .= "<LI>Correct any fields marked with a warning</LI>\n";
    }
    $htmlBuf .= "<LI>Validate this configuration and your changes by ";
    $htmlBuf .= "clicking the Update Configuration button</LI>\n";
    $htmlBuf .= "</UL>\n";

    $htmlBuf .= "If your new configuration doesn't show up, hit the <b>reload</b> button\n";
    print $htmlBuf;
    
}
elsif ($action eq "update")
{
    $formURL = &ExpandVal ($Vars{'$surfHtmlURL'});

    $htmlBuf = "<P>\n";
    $htmlBuf .= "<b>SurfReport</b> has updated your configuration ";
    $htmlBuf .= "file<br>";
    

    $htmlBuf .= "<br>If you find any fields marked with a warning\n";
    $htmlBuf .= ", please\n<UL>\n";
    $htmlBuf .= "<LI>Correct the error</LI>\n";
    $htmlBuf .= "<LI>Validate your changes by clicking the ";
    $htmlBuf .= "Update Configuration button</LI>\n";
    $htmlBuf .= "</UL>\n";

    $htmlBuf .= "<br>If the configuration looks fine, you must now\n";
    $htmlBuf .= "<UL>\n";
    $htmlBuf .= "<LI><A HREF=\"$this/form\">";
    $htmlBuf .= "Configure SurfReport's interface form</a></LI>\n";
    $htmlBuf .= "</UL>\n";

	if ($formConfigured == 1)
	{
		$htmlBuf .= "<br>Then, you can\n";
		$htmlBuf .= "<UL>\n";
		$htmlBuf .= "<LI><A HREF=\"$formURL\">";
		$htmlBuf .= "Try SurfReport</a></LI>\n";
		$htmlBuf .= "</UL>\n";
	}

    $htmlBuf .= "If your new configuration doesn't show up, hit the <b>reload</b> button\n";
    print $htmlBuf;
    
}
elsif ($action eq "reset")
{
   
    $htmlBuf = "<P>\n";
    $htmlBuf .= "<b>SurfReport</b> is now showing the default ";
    $htmlBuf .= "configuration as it appeared\n";
    $htmlBuf .= "the very first time you ran this program\n<BR>";
   

    $htmlBuf .= "<br>You can\n";
    $htmlBuf .= "<UL>\n";
    $htmlBuf .= "<LI>Review and change any fields</LI>\n";
    $htmlBuf .= "<LI>Accept this configuration by clicking the ";
    $htmlBuf .= "Update Configuration button</LI>\n";
    $htmlBuf .= "<LI><A HREF=\"$this/file\">";
    $htmlBuf .= "Compare this configuration with your ";
    $htmlBuf .= "current configuration</A></LI>\n";
    $htmlBuf .= "</UL>\n";


    print $htmlBuf;
    
}
elsif ($action eq "file")
{
   
    $htmlBuf = "<P>\n";
    $htmlBuf .= "<b>SurfReport</b> is now showing your current ";
    $htmlBuf .= "configuration\n<BR>";

   
    $htmlBuf .= "<br>You can\n";
    $htmlBuf .= "<UL>\n";
    $htmlBuf .= "<LI>Review and change any fields</LI>\n";
    $htmlBuf .= "<LI>Accept this configuration by clicking the ";
    $htmlBuf .= "Update Configuration button</LI>\n";
    $htmlBuf .= "<LI><A HREF=\"$this/reset\">";
    $htmlBuf .= "Compare this configuration with ";
    $htmlBuf .= "the default configuration</A></LI>\n";
    $htmlBuf .= "</UL>\n";

    $htmlBuf .= "If your new configuration doesn't show up, hit the <b>reload</b> button\n";

    print $htmlBuf;
    
}
elsif ($action eq "alias")
{
   
    $htmlBuf = "<P>\n";
    $htmlBuf .= "<b>SurfReport</b> looked in your web server and found ";
    if ($numServerAlias == 0)
    { 
	$htmlBuf .= "no new alias\n";
    }
    elsif ($numServerAlias == 1)
    {
	$htmlBuf .= "1 new alias\n";
    }
    else
    {
	$htmlBuf .= "$numServerAlias new aliases\n";
    }
    
    $htmlBuf .= "<br>";

    if ($numServerAlias > 0)
    {
	$htmlBuf .= "<br>Now, please\n";
	$htmlBuf .= "<UL>\n";
	$htmlBuf .= "<LI>Review each alias</LI>\n";
	$htmlBuf .= "<LI>Uncheck any alias you don't want to include</LI>\n";
	$htmlBuf .= "<LI>Validate new aliases by clicking the ";
	$htmlBuf .= "Update Configuration button</LI>\n";
    
	$htmlBuf .= "</UL>\n";

	$htmlBuf .= "If your new configuration doesn't show up, hit the <b>reload</b> button\n";
    }
    print $htmlBuf;
    
}


######### action tag, submit button ########

# self referring

#update is the standard action, the only one accessed by clicking
#the Update Config button
#all other actions are available as anchors instead
$state = "update";

$htmlBuf = "<Form METHOD=POST ACTION=\"$this/$state\">\n";
$htmlBuf .= "<CENTER>\n<P>";
$htmlBuf .= "<INPUT TYPE =\"submit\" NAME = \"action\" VALUE=\"Update Configuration\">";
$htmlBuf .= "</CENTER>\n";

print $htmlBuf;

####################### PATH NAMES ###########################

###  sub title ###
$htmlBuf = $htmlLine;
$htmlBuf .= "<PRE>";
$htmlBuf .= "<A NAME =paths></A>";
#$htmlBuf .= $links;
$htmlBuf .= &Title (3, "Path to");
print $htmlBuf;


### log path ###

if ($configured == 0)
{
    # set up a default path only for NT running IIS
    # otherwise an arbitrary default may be too confusing
    if ($platform eq "OS_NT" && $ENV{SERVER_SOFTWARE} =~ /microsoft/i)
    {
	# standard nt log files location (with IIS)
	$drive = $ENV{SYSTEMDRIVE};
	$drive = "C:" unless $drive;
	
	$path = "$drive/winnt/system32/LogFiles/";
    }
    else
    {
	$path = "";
    }
    
}
else
{
    $path = &ExpandVal ($Vars{'$accessLogPath'});
    
    if (!opendir (DIR, $path))
    {
	$warn = 1;
    }
    else
    {
	closedir (DIR);
	$warn = 0;
    }

   
}

if ($warn == 0)
{
    $htmlBuf = "<STRONG>        logs folder </STRONG>";
}
else
{
    $htmlBuf = "        logs folder ";
}

$htmlBuf .= &FormTextTag ('$accessLogPath', $path, 65);
$htmlBuf .= "\n                    ";
if ($warn == 1)
{
    $htmlBuf .= "\n            <STRONG>warning</STRONG> ";
    $htmlBuf .= "*** Can't access this directory. $! ***";
}

$htmlBuf .= "\n\n";

print $htmlBuf; 

### docroot path ###

if ($configured == 0)
{
    # set default to the level above web-home
	$path = $ENV{SURFREPORT_WEBHOME};
	chop ($path);

	if (($pos = rindex ($path, "/")) == $[ - 1)
	{
		if (($pos = rindex ($path, "\\")) == $[ - 1)
		{
			$pos = length ($path) - 1;
		}
	}

	$path = substr ($path, 0, $pos + 1);

    
}
else
{
    $path = $Properties{docroot}; 
    
    if (!opendir (DIR, $path))
    {
	$warn = 1;
    }
    else
    {
	closedir (DIR);
	$warn = 0;
    }

   
}

if ($warn == 0)
{
    $htmlBuf = "<STRONG>  web document root </STRONG>";
}
else
{
    $htmlBuf = "  web document root ";
}

$htmlBuf .= &FormTextTag ('PROPERTY_docroot', $path, 65);
$htmlBuf .= "\n                    ";
if ($warn == 1)
{
    $htmlBuf .= "\n            <STRONG>warning</STRONG> ";
    $htmlBuf .= "*** Can't access this directory. $! ***";
}

$htmlBuf .= "\n\n";

print $htmlBuf; 




##########################  URLs ###########################
###  sub title ###
$htmlBuf = $htmlLine;
$htmlBuf .= "<A NAME =URLs></A>";
#$htmlBuf .= $links;
$htmlBuf .= &Title (3, "URLs");
print $htmlBuf;

### server url ###
$warn = 0;
if ($configured == 0)
{
    
    $serverURL = "http://$serverName";

    # include non standard http port in URLs
    if (defined ($serverPort) && $serverPort ne "" && $serverPort ne "80")
    {
	$serverURL .= ":" . $serverPort;
    }
    $serverURL .= "/";
}
else
{
    $serverURL = &ExpandVal ($Vars{'$siteURL'});
}

$htmlBuf = "<STRONG>             Server </STRONG>";
$htmlBuf .= &FormTextTag ('$siteURL', $serverURL, 65);

$htmlBuf .= "\n\n";

print $htmlBuf; 

$srFolder = $ENV{SURFREPORT_WEBHOME};
chop ($srFolder);
$srFolder = substr ($srFolder, rindex ($srFolder, "/") + 1);
$srFolder .= "/";

### site url ###
$warn = 0;
if ($configured == 0)
{
    if (!$ENV{SCRIPT_NAME})
    {
	$warn = 1;
    }
    else
    {
	
	$scriptName = $ENV{SCRIPT_NAME};

	# scrap program name
	$cgiURL = substr( $scriptName, 0, rindex ( $scriptName, '/') + 1);

       
	#try fetching the user, run a backward 
	# difference between cgiPath and script name
	
	#get path to this directory (cgi-bin)
	$path = `pwd`;
    chop ($path);
    $path .= "/";
    
	$url = $cgiURL;
	$ui = rindex ($url, '/');
	$pi = rindex ($path, '/');
	$script = "";
	while ($ui >= $[)
	{
	    last if (substr ($path, $pi) ne substr ($url, $ui));
	    
	    $script = substr ($path, $pi + 1);	
	    $ui = rindex ($url, '/', --$ui);
	    $pi = rindex ($path, '/', --$pi);
	    
      	}
	
	# don't want first slash
	$cgiURL =~ s/^\///;

	if ($script !~ /cgi/i)
	{
	    # cgi-bin folder is aliased
	    # this relies on the cgi folder alias
	    # containing the cgi letters
	    # better than nothing
		if ($cgiURL =~ /\/.*cgi/)
		{
			$script = $` . "/";
		}

	    #$script = substr ($cgiURL, index ($cgiURL, "cgi"));
	}

       
	# first look for a difference, happens with /~user/
	# for instance
	$user = "";
	if (($ui = index ($cgiURL, $script)) >= $[)
	{
	    
	    if ($ui == $[) 
	    {
		# no difference, look for the surf folder
		# (running from the surfreport folder)
		if (($ui = index ($cgiURL, $srFolder)) >= $[)
		{
		    
		    if ($ui == $[)
		    {
			# begins with SR folder, no user
			$user = "";
		    }
		    elsif ($ui >$[)
		    {
			# include SR folder, extract user
			$user = substr ($cgiURL, $[, $ui);
		    }
		    else 
		    {
			# does not include SR folder, look for
			# a cgi folder
			if (($ui = index ($cgiURL, "cgi")) >= $[)
			{
			    if ($ui == $[)
			    {
				$user = "";
			    }
			    else
			    {
				$user = substr ($cgiURL, $[, $ui);
			    }
			}
		    }
		}
		    
			
	    }
	    else
	    {
		# there is a diff, get user
		$user = substr ($cgiURL, $[, $ui);
	    }
	    
	}

	$cgiURL = substr ($cgiURL, length ($user));

    }

    $webURL = $serverURL.$user;
}
else
{
    $webURL = &ExpandVal ($Vars{'$userURL'});
     
}

$htmlBuf = "<STRONG>           Web site </STRONG>";
$htmlBuf .= &FormTextTag ('$userURL', $webURL, 65);

$htmlBuf .= "\n\n";

print $htmlBuf; 

### SR url ###
$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $srURL = &ExpandVal ($Vars{'$srURL'});
}
else
{
    $srURL = $webURL.$srFolder;
}

$htmlBuf = "<STRONG>  SurfReport folder </STRONG>";
$htmlBuf .= &FormTextTag ('$srURL', $srURL, 65);

$htmlBuf .= "\n\n";

print $htmlBuf; 

# the following URL's are inferred
# not user changeable
### SR output url ###
$srOutURL = $srURL. "srout/";
$htmlBuf = &FormInputTag ('HIDDEN', '$srOutURL', $srOutURL, 0);
#print $htmlBuf; 

### form url ###
$formURL = $srURL."surfreport.html";
$htmlBuf = &FormInputTag ('HIDDEN', '$surfHtmlURL', $formURL, 0);
#print $htmlBuf; 

### img url ###
$imgURL = $srURL."gifs/";
$htmlBuf = &FormInputTag ('HIDDEN', '$imgURL', $imgURL, 0);
#print $htmlBuf; 


############# Personalize report ################

###  sub title ###
$htmlBuf = $htmlLine;
$htmlBuf .= "<A NAME=report></A>";
#$htmlBuf .= $links;
$htmlBuf .= &Title (3, "Personalize Your Reports");
print $htmlBuf;

### user name ###
$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $name = &ExpandVal ($Vars{'$yourHost'});
}
else
{
    $name =  "My Site";
}

$htmlBuf = "<STRONG>        site's name </STRONG>";
$htmlBuf .= &FormTextTag ('$yourHost', $name, 65);
$htmlBuf .= "\n            <STRONG>example</STRONG> ";
$htmlBuf .= "Top 40 Visitors That Have Accessed <B>$name</B> at Least Once";
$htmlBuf .= "\n\n";

print $htmlBuf; 

### banner url ###
$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $bannerURL = &ExpandVal ($Vars{'$bannerImgURL'});
}
else
{
    $bannerURL = $imgURL . "surf_results.gif";
}

$htmlBuf = "<STRONG>       banner image </STRONG>";
$htmlBuf .= &FormTextTag ('$bannerImgURL', $bannerURL, 65);
$htmlBuf .= "\n\n<CENTER><IMG SRC = \"$bannerURL\" BORDER=1></CENTER>";

$htmlBuf .= "\n\n";

print $htmlBuf; 

### bck url ###
$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $bgURL = &ExpandVal ($Vars{'$bgImgURL'});
}
else
{
    $bgURL = $imgURL . "surf_background.gif";
}

$htmlBuf = "<STRONG>   background image </STRONG>";
$htmlBuf .= &FormTextTag ('$bgImgURL', $bgURL, 65);
$htmlBuf .= "\n\n<CENTER><IMG SRC = \"$bgURL\" BORDER=1></CENTER>";

$htmlBuf .= "\n\n";

print $htmlBuf; 

### text colors  ###
$htmlBuf = "<STRONG>             Colors</STRONG>\n\n";
print $htmlBuf;

$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $color = &ExpandVal ($Vars{'$bgColor'});
}
else
{
    $color =  "FFFFFF";
}

$htmlBuf = "<STRONG>         background </STRONG>";
$htmlBuf .= &FormTextTag ('$bgColor', $color, 6);
$htmlBuf .= "\n";

print $htmlBuf; 

$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $color = &ExpandVal ($Vars{'$textColor'});
}
else
{
    $color =  "000000";
}

$htmlBuf = "<STRONG>               text </STRONG>";
$htmlBuf .= &FormTextTag ('$textColor', $color, 6);
$htmlBuf .= "\n";

print $htmlBuf; 

$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $color = &ExpandVal ($Vars{'$linkColor'});
}
else
{
    $color =  "D53C83";
}

$htmlBuf = "<STRONG>              links </STRONG>";
$htmlBuf .= &FormTextTag ('$linkColor', $color, 6);
$htmlBuf .= "\n";

print $htmlBuf; 

$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $color = &ExpandVal ($Vars{'$vlinkColor'});
}
else
{
    $color =  "08AEFB";
}

$htmlBuf = "<STRONG>      visited links </STRONG>";
$htmlBuf .= &FormTextTag ('$vlinkColor', $color, 6);
$htmlBuf .= "\n";

print $htmlBuf; 

$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $color = &ExpandVal ($Vars{'$alinkColor'});
}
else
{
    $color =  "FFFFFF";
}

$htmlBuf = "<STRONG>       active links </STRONG>";
$htmlBuf .= &FormTextTag ('$alinkColor', $color, 6);
$htmlBuf .= "\n\n";

print $htmlBuf; 

### document url ###
$warn = 0;
#we get the default value above
if ($configured != 0)
{
    $docURL = &ExpandVal ($Vars{'$docURL'});
}
else
{
    $docURL = $webURL;
}

$htmlBuf = "<STRONG>     documents root </STRONG>";
$htmlBuf .= &FormTextTag ('$docURL', $docURL, 65);
$htmlBuf .= "\n                    ";
$htmlBuf .= "When your report shows HTML documents titles, ";
$htmlBuf .= "they will be based on this URL";
$htmlBuf .= "\n\n";

print $htmlBuf;


############# REFERRERS ###############

###  sub title ###
$htmlBuf = $htmlLine;
$htmlBuf .= "<A NAME=referrer></A>";
#$htmlBuf .= $links;
$htmlBuf .= &Title (3, "Referrers");
print $htmlBuf;


### excluded referrer list ###

$warn = 0;
@XRefList = ();

if ($configured == 0)
{
    @server = &SplitAddress ($serverName);
    
    $isIP = pop (@server);

    if ($isIP == 1)
    {
	# IP address,  "38.215.89.*"
	$name = join ('.', @server[$[ .. $#server - 1]);
	$name .= ".*";
    }
    else
    {
	# host name, "*.domain.com"
	$name = "*.";
	$name .= join ('.', @server[$[+1 .. $#server]);
    }
    $XRefList[0] = $name;

}
else
{
   &GetListValue ($Vars{'@XReferrers'}, *XRefList);
   $name = &GetListStr (@XRefList); 
    
}

$htmlBuf = "<STRONG>      referrer list </STRONG>";
$htmlBuf .= &FormTextTag ('@XReferrers', $name, 65);
$htmlBuf .= "\n                     ";
$htmlBuf .= "The referring pages report will exclude referrals from these domains";
$htmlBuf .= "\n\n";

print $htmlBuf; 

############# CGIs ###############

###  sub title ###
$htmlBuf = $htmlLine;
$htmlBuf .= "<A NAME=cgi></A>";
#$htmlBuf .= $links;
$htmlBuf .= &Title (3, "CGI & Server Programs");
print $htmlBuf;


### cgi extensions list ###

$warn = 0;
@CGIList = ();

if ($configured == 0)
{
    if ($platform eq "OS_NT")
    {
	@CGIList = (".exe", ".cgi", ".asp");
    }
    else
    {
	@CGIList = (".cgi", ".pl");
    }
}
else
{
    &GetListValue ($Vars{'@CGIExtensions'}, *CGIList);    
}

$name = &GetListStr (@CGIList); 

$htmlBuf = "<STRONG>           cgi list </STRONG>";
$htmlBuf .= &FormTextTag ('@CGIExtensions', $name, 65);
$htmlBuf .= "\n                     ";
$htmlBuf .= "List every file type that should be treated as a cgi or server side program";
$htmlBuf .= "\n\n";

print $htmlBuf; 

############# FILTERS ###############

$htmlBuf = $htmlLine;
$htmlBuf .= "<A NAME=filters></A>";
#$htmlBuf .= $links;
$htmlBuf .= &Title (3, "Filters");
print $htmlBuf;

if (!defined ($ENV{SURFREPORT_MULTIUSER}) || 
    $ENV{SURFREPORT_MULTIUSER} ne "YES")
{
# don't show the master filter in a multiuser environment

##### master filter #########
$warn = 0;

if ($configured == 0)
{
    $masterFilter = "";
}
else
{
    $masterFilter = $Properties{filter}; 
}


$htmlBuf = "<STRONG>      master filter </STRONG>";
$htmlBuf .= &FormTextTag ('PROPERTY_filter', $masterFilter, 65);
$htmlBuf .= "\n                     ";
$htmlBuf .= "If you share log files with other web sites,";
$htmlBuf .= "\n                     ";
$htmlBuf .= "use this filter to block all hits but your own.";
$htmlBuf .= "\n                     ";
$htmlBuf .= "This filter can either be a path name (i.e: <B>mysite/*</B> or <B>~myusername/*</B>)";
$htmlBuf .= "\n                     ";
$htmlBuf .= "or a server IP address, if you have logs in microsoft format";
$htmlBuf .= "\n                     ";
$htmlBuf .= "and are using virtual servers with IIS (i.e: <B>207.123.87.7</B>)";

$htmlBuf .= "\n\n";


print $htmlBuf; 

} # endif !SURFREPORT_MULTIUSER

##### HEAD filter #########
$warn = 0;

if ($configured == 0)
{
    $xHead = 1;
}
else
{
    $xHead = &ExpandVal ($Vars{'$xHeadReq'}); 
}


$htmlBuf = "<STRONG>   no HEAD requests </STRONG>";
$htmlBuf .= &FormCheckBox ('$xHeadReq', $xHead);
$htmlBuf .= "\n                     ";
$htmlBuf .= "This type of request just returns information headers";
$htmlBuf .= "\n                     ";
$htmlBuf .= "and is often generated by monitoring or probing programs";
$htmlBuf .= "\n\n";

print $htmlBuf; 


if ($platform ne "OS_NT")
{
############# COMPRESSION ###############

$htmlBuf = $htmlLine;
$htmlBuf .= "<A NAME=compress></A>";
#$htmlBuf .= $links;
$htmlBuf .= &Title (3, "Compressed Logs");
print $htmlBuf;

##### get compressors paths #########
$warn = 0;

%exe = ();
$fHasWebGzip = 0;
$fHasWebCompress = 0;
$fHasGzip = 0;
$fHasCompress = 0;

&GetCompressHome (*exe);
if ($exe{gunzip})
{
    $gzipHome = $exe{gunzip};
    $fHasWebGzip = 1;
}
if ($exe{uncompress})
{
    $compressHome = $exe{uncompress};
    $fHasWebCompress = 1;
}
if ($configured == 0)
{
    $compressPath = "";
}
else
{
    $compressPath = $Properties{compress}; 
}

if ($compressPath ne "")
{
   
    # verify validity of this path
    $app = $compressPath . "gunzip";
    if (-e $app && -x $app)
    {
	$fHasGzip = 1;
    }
    $app = $compressPath . "uncompress";
    if (-e $app && -x $app)
    {
	$fHasCompress = 1;
    }
	
    if ($fHasGzip == 0 && $fHasCompress == 0)
    {
	$warn = 1;
    }
    
} 

if ($warn == 0)
{
    $htmlBuf = "<STRONG>   decompressor path </STRONG>";   
}
else
{
    $htmlBuf = "   decompressor path ";
}

$htmlBuf .= &FormTextTag ('PROPERTY_compress', $compressPath, 65);

$htmlBuf .= "\n                     ";

if ($compressPath ne "" )
{
    if ($fHasCompress == 1 && $fHasGzip == 1)
    {
	$htmlBuf .= "Both gunzip and uncompress are executable from <B>$compressPath</B>";
    }
    elsif ($fHasCompress == 1 && $fHasGzip == 0)
    {
	$htmlBuf .= "uncompress is available using <B>$compressPath" . "uncompress</B>";	
	$htmlBuf .= "\n                     ";
	$htmlBuf .= "*** gunzip is <strong>not</strong> executable from <B>$compressPath</B>";
    }
    elsif ($fHasCompress == 0 && $fHasGzip == 1)
    {
	$htmlBuf .= "gunzip is available using <B>$compressPath" . "gunzip</B>";
	$htmlBuf .= "\n                     ";
	$htmlBuf .= "*** uncompress is <strong>not</strong> executable from <B>$compressPath</B>";
    }
    elsif ($fHasCompress == 0 && $fHasGzip == 0)
    {
	$htmlBuf .= "\n            <STRONG>warning</STRONG> ";
	$htmlBuf .= "*** Cannot run neither gunzip nor uncompress from <B>$compressPath</B>";
    }
}
elsif ($fHasWebGzip == 1 && $fHasWebCompress == 1)
{
    $htmlBuf .= "Leave this field blank, you have both gunzip and uncompress";
    $htmlBuf .= "\n                     ";
    $htmlBuf .= "paths set in your Web environment as ";
    $htmlBuf .= "<B>$gzipHome</B> and <B>$compressHome</B>";
}
elsif ($fHasWebGzip == 1)
{
    $htmlBuf .= "gunzip is available through your Web environment as <B>$gzipHome</B>";
    $htmlBuf .= "\n                     ";
    $htmlBuf .= "Change this field only if you want to use another compressor.";
}
elsif ($fHasWebCompress == 1)
{
    $htmlBuf .= "uncompress is available through your web environment as <B>$compressHome</B>";
    $htmlBuf .= "\n                     ";
    $htmlBuf .= "If you use gzip, you must set its path in the above field, i.e:<B>/usr/bin/</B>";

}
else
{
    $htmlBuf .= "Neither gunzip nor uncompress are available through your Web environment";
    $htmlBuf .= "\n                     ";
    $htmlBuf .= "If you want to read compressed log files, enter the path";
    $htmlBuf .= "\n                     ";
    $htmlBuf .= "to your decompression utility, ";
    $htmlBuf .= "i.e: <b>/usr/bin/</b>";

}

$htmlBuf .= "\n\n";


print $htmlBuf; 

} # endif platform ne NT

############# ALIASES  ################

###  sub title ###
$htmlBuf = $htmlLine;
$htmlBuf .= "<A NAME=alias></A>";
#$htmlBuf .= $links;
$htmlBuf .= &Title (3, "Aliases");
print $htmlBuf;

    
### virtual domain name ###
$warn = 0;
if ($configured == 0)
{
    $name = "";
}
else
{
    $name = &ExpandVal ($Vars{'$realDomainName'});
    
}

$htmlBuf = "<STRONG>virtual domain name </STRONG>";
$htmlBuf .= &FormTextTag ('$realDomainName', $name, 65);
$htmlBuf .= "\n                     ";
$htmlBuf .= "Only for log files that include a virtual domain field";
$htmlBuf .= "\n\n";

print $htmlBuf; 

### directory prefix ###
$warn = 0;
if ($configured == 0)
{
    $name = "";
}
else
{
    $name = &ExpandVal ($Vars{'$dirPrefix'});
    
}

$htmlBuf = "<STRONG>   directory prefix </STRONG>";
$htmlBuf .= &FormTextTag ('$dirPrefix', $name, 65);
$htmlBuf .= "\n                     ";
$htmlBuf .= "This directory will be removed from request names";
$htmlBuf .= "\n\n";

print $htmlBuf; 

### directory suffix ###
$warn = 0;
if ($configured == 0)
{
    $name = "index.html";
}
else
{
    $name = &ExpandVal ($Vars{'$dirSuffix'});
    
}

$htmlBuf = "<STRONG>  default page name </STRONG>";
$htmlBuf .= &FormTextTag ('$dirSuffix', $name, 65);
$htmlBuf .= "\n                     ";
$htmlBuf .= "Requests that omit an html page name will end with <B>$name</B>";
$htmlBuf .= "\n\n";

print $htmlBuf; 

### alias list
$htmlBuf = "";
$numAlias = 0;

if ($configured != 0)
{
    # list existing aliases
    %Aliases = ();
    $numAlias = &GetAliases ($Vars{'%Aliases'}, *Aliases);
    $htmlBuf .= "<STRONG>current file aliases </STRONG>\n";    
    if ($numAlias == 0)
    {
	$htmlBuf .= "                     none...\n";
    }
    else
    {
	$htmlBuf .= &DisplayAliases (0, %Aliases, "                   ");
    }
    $htmlBuf .= "\n";
}

if ($haveServerAlias == 1)
{
    #list server aliases
    $htmlBuf .= "<STRONG> Web server aliases </STRONG>\n";    
    if ($numServerAlias == 0)
    {
	$htmlBuf .= "                     none...\n";
    }
    else
    {
	$htmlBuf .= &DisplayAliases ($numAlias, %ServerAliases, "                   ");
    
        $numAlias += $numServerAlias;	
    }
    
    $htmlBuf .= "\n";
}

#list new empty aliases
$htmlBuf .=  "<STRONG>    make new aliases </STRONG>\n";
$htmlBuf .= &DisplayEmptyAliases ($numAlias, 5,"                   ");
$htmlBuf .= "                     ";
$htmlBuf .= "The left string will be replaced by the right string in ";
$htmlBuf .= "matching requests\n";
$htmlBuf .= "\n                     ";
$htmlBuf .= "All <b>checked</B> aliases will be included ";
$htmlBuf .= "in the current aliases list";
$htmlBuf .= "\n                     ";
$htmlBuf .= "when you click the <b>Update Configuration</B> button\n";

if ($haveServerAlias == 0 && $platform ne "OS_NT")
{
    $htmlBuf .= "\n<CENTER>";
    $htmlBuf .= "<A HREF = \"$this/serverAlias\">";
    $htmlBuf .= "Look for aliases on your Web server</A></CENTER>\n";
}

print $htmlBuf;

###################### ACTIONS ###############

###  sub title ###
$htmlBuf = "</PRE>";
$htmlBuf .= $htmlLine;
#$htmlBuf .= "<A NAME=actions></A>";
#$htmlBuf .= $links;
#$htmlBuf .= &Title (3, "Actions");
print $htmlBuf;

$formURL = &ExpandVal ($Vars{'$surfHtmlURL'});

$htmlBuf = "<CENTER><br><br>\n";
$htmlBuf .= "<INPUT TYPE =\"submit\" VALUE=\"Update Configuration\"><br><br>\n";

if ( $Vars{'$configured'} != 0)
{
    $htmlBuf .= "<A HREF=\"$this/form\">";
    $htmlBuf .= "Configure SurfReport's form interface</A><br><br>\n";

	if ($formConfigured != 0)
	{
		$htmlBuf .= "<A HREF=\"$formURL\">";
		$htmlBuf .= "Try SurfReport</a><br><br>\n";
	}
}
$htmlBuf .= "<A HREF=\"$this/reset\">";
$htmlBuf .= "Display default configuration</A><br><br>\n";
$htmlBuf .= "<A HREF=\"$this/file\">";
$htmlBuf .= "Display last validated configuration</A><br>\n";
$htmlBuf .= "</CENTER>\n";

print $htmlBuf;

print $htmlLine;

&PrintHTMLEnd();


#################################  SUBROUTINES  ###############################

sub PrintHTMLEnd
{
    print "<H5>SurfReport 2.1.7<br>Copyright &copy; 1996, 1997 <A HREF = \"http://www.bienlogic.com\">Bien
Logic, Inc.</A></H5>";

    print "</BODY></HTML>";
}

sub Title
{
    local ($size, $text) = @_;
    local ($buf);
    $buf = "\n<H$size>$text</H$size>\n";
}

sub FormInputTag
{
    local ($type, $name, $value, $checked) = @_;
    local ($buf);
    $buf = "<INPUT TYPE=\"$type\" NAME=\"$name\" VALUE=\"$value\"";
    if (defined ($checked) && $checked == 1)
    {
	$buf .= " CHECKED";
    }
    $buf .= ">";
}

sub FormTextTag
{
    local ($name, $value, $size) = @_;
    local ($buf);

    $buf = "<INPUT NAME=\"$name\" VALUE=\"$value\" SIZE=\"$size\"";
    $buf .= ">";
}

sub FormMenu
{
    local ($name, $selected, %options) = @_;
    local ($buf, $n, $value);
    
    $buf = "<SELECT NAME=\"$name\">\n";
    
    foreach $name (sort(keys %options))
    {
	$buf .= "<OPTION VALUE=\"";
	$value = $options{$name};
	$buf .= $value."\"";
	if ($value eq $selected)
	{
	    $buf .= " SELECTED";
	}
	$buf .= ">$name\n";
    }
    $buf .= "</SELECT>";
     
}

sub FormRadio
{
    local ($name, $selected, @list) = @_;
    local ($buf, $n);
    
    $buf = "\n<UL>\n";
    for ($n = 0; $n < $#list+1; $n++)
    {
	$buf .= "<BR><INPUT TYPE=\"radio\" NAME=\"$name\" ";
	$buf .= "VALUE=\"$list[$n]\"";
	if ($n == $selected)
	{
	    $buf .= " CHECKED";
	}
	$buf .= ">$list[$n]";
    }
    $buf .= "</UL>\n";
  
}

sub FormCheckBox
{
    local ($name, $selected) = @_;
    local ($buf);
    
    
    $buf = "<INPUT TYPE=\"CHECKBOX\" NAME=\"$name\" VALUE = \"on\"";
    if ($selected == 1)
    {
	$buf .= " CHECKED";
    }
    $buf .= ">";
  
}


sub GetFormInput
{
    
    local (@pairs, $len, $buffer, $name, $value);
 
    
    if ($ENV{REQUEST_METHOD} eq "POST")
    {
	
	if (! ($len = $ENV{CONTENT_LENGTH}))
	{
	    return "cgi error: CONTENT_LENGTH environment variable not defined\n";
	}
	elsif ($len == 0)
	{
	  return "cgi error: CONTENT_LENGTH is zero\n";
	}


	read(STDIN, $buffer, $len);
	@pairs = split( /&/, $buffer);
	
	foreach $pair (@pairs)
	{
	    ($name, $value) = split(/=/, $pair);
	    $value =~ tr/+/ /;
	    $value =~ s/%([a-fA-F0-9]{1,2})/pack("C", hex($1))/eg;
	    #$value =~ s/\r//g;
	
	
	    $Form{$name} = $value;
	}
       
    }
    else
    {
       return "cgi error: did not use POST as method\n"; 
    }

    return "";
    
   
}

# make a replacement list for perl variables
# transfer form parameters into an array who's values
# are valid perl values
sub MakeRepList
{
    local (*RepList, %Form) = @_;
    local ($val, $aliases, $n);
    local (@addSlash);

    @addSlash = ('$accessLogPath',
		 '$siteURL',
		 '$userURL',
		 '$srURL',
		 '$docURL');

    $aliases = "(";

    
    foreach $key (keys (%Form))
    {
	if ($key =~ /^alias(\d+)/)
	{
	    # if this alias made it in the form 
	    # it means its box was checked
	    $n = $1;
	    $aliases .= "\"" . $Form{"aliasKey$n"} . "\", ";
	    $aliases .= "\"". $Form{"aliasVal$n"} . "\",\n";
	    
	    next;
	    
	}	
	    
	
	$name = $key;
       
	# keys are mostly perl variable names
	# must convert hex chars inside key names too 
        $name =~ s/%([a-fA-F0-9]{1,2})/pack("C", hex($1))/eg;
	
	next if ($name !~ /^[\$\%\@]{1,1}/);

        # quote the value of a perl variable

	if ($name =~ /^[\@]{1,1}/)
	{
	    local (@list);

	    # list value
	    &GetListValue ($Form{$key}, *list);
	    $value =  &GetListPerlStr (@list);
	}
	else
	{
	    $value = "\"" . $Form{$key} . "\"";
	}
	$RepList{$name} = $value;

	
    }

    $aliases .= ")";
    $RepList{'%Aliases'} = $aliases;

    # make sure our paths are slash terminated 
    foreach $name (@addSlash)
    {
    	$val = $RepList{$name};
    	
    	if ($platform eq "OS_NT")
    	{
	    # impose unix style slashes
	    $val =~ s/\\/\//g;
    	}
	
	$val =~ s/\/*\"$/\/\"/;
	$RepList{$name} = $val;
	
    }

    # these 3 URL must be in sync with the variable
    # the user entered in the form
    
    $val = $RepList{'$srURL'};
    $val =~ /^\"(.*)\"$/;
    
    $RepList{'$srOutURL'} = "\"". $1 . "srout/\"";
    $RepList{'$surfHtmlURL'} = "\"". $1 . "surfreport.html\"";
    $RepList{'$imgURL'} = "\"". $1 . "gifs/\"";


}


sub MakeFormRepList
{
    local (*RepList, %Vars) = @_;
    local ($val);

    # Vars holds the current settings of
    # ALL variables in the form
    # Form hold only the variables returned by
    # the cgi protocol from which
    # all unchecked checkboxes names are missing 

    foreach $key (keys (%Vars))
    {
	if (defined ($Form{$key}))
	{
	    $RepList{$key} = $Form{$key};
	}
	else
	{
	    # missing check box, value is 'off'
	    $RepList{$key} = "off";
	}
	
	
    }
}

# replace perl variables values by the ones
# passed in an associative array

sub UpdateConfigVars
{

    local ($tmpname, $filename, *Vars, %RepList) = @_;
    local ( $srFolder, $nRep, $line);
    local ($val, $newVal, $out, $error);

    
    if (!open (IN, "$filename"))
    {
	$error = "Can't open $filename: $!\n"; 
	if (!-e $filename)
	{
	 $error .=  "This configuration file is not in your config folder\n";
	}
	elsif ( !-r $filename || !-w $filename)
	{
	 $error .=  "This configuration file must have WEB ";
	 $error .= "read/write permissions\n";
	 
	}

	return $error;
    }

    if (!open (OUT, ">$tmpname"))
    {
	close IN;
	$error = "Can't create safety file $tmpname: $!\n";
	return $error;

    }
    

    $nRep = 0; 
    while ($line = <IN>)
    {
	if ($line !~ /^\s*([\$@%]{1,1}[a-zA-Z0-9]+)\s*=\s*([^;]+)(;*)/ )
	{
	    print OUT $line;
	    next;
	}
	if (!defined $Vars{$1})
	{
	    $val = $2;
	    
	    while ($3 eq "")
	    {
		$line  = <IN>;
		$line =~ /(m?)([^;]+)(;*)/;
		$val .= $2;
	    }
	    if (defined $RepList{$1} && $val ne $RepList{$1})
	    {
		$Vars{$1} = $RepList{$1};
		
		$nRep ++;
	    }
	    else
	    {
		$Vars{$1} = $val;
	    }
	    $out = $1." = ".$Vars{$1}.";\n"; 
	    print OUT  $out;
	    
	
	}
    }

    close (IN);
    close (OUT);
    if (rename ($tmpname, $filename) == 0)
    {
	$error = "Can't rename '$tmpname' into '$filename'. $!";
	return $error;
    }
    chmod 0666, $filename;

    return "";
}

#
# get user properties stored in a text file
#
sub GetProperties
{
    local ($fileName, *Vars) = @_;

    local ($foundVars);
    local ($key, $val, $error);

    $error = "";

    if (open (PROPERTIES, $fileName))
    {
      
	$foundVars = 0;
      getvars:
	while (<PROPERTIES>)
	{
	    if (/^\s*#/)
	    {
		next getvars;
	    }

	    if (/^\s*(\w+)\s*=\s*([^\n#;]*)/ )
	    {
		$key = $1;
		$val = $2;

		$Vars{$key} = $val;
		$foundVars++;
	    }	
	}
    
	close (PROPERTIES);
    }
   else
   {
	$error = "Can't open $inFile: $!\n"; 
        if (!-e $filename)
        {
	     $error .=  "This property sheet is not in your configuration folder\n";
        }
        elsif (!-r $fileName || !-w $fileName)
        {
	    $error .=  "This property sheet must have WEB";
	    $error .= "read/write permissions";
        }
    }

    return $error;
  
}

#
# update properties from the form input
#
sub UpdateProperties
{
    local ($inFile, *Properties, %Form) = @_;

    local ($key, $val, $srTmpFolder, $tmpFile, $line, $error);

    if (!open (IN, "$inFile"))
    {
      $error = "Can't open $inFile: $!\n"; 
      if (!-e $inFile)
      {
	 $error .=  "This property sheet is not in your configuration folder\n";
      }
      elsif (!-r $inFile || !-w $infile)
      {
	 $error .=  "This property sheet must have WEB";
	 $error .= "read/write permissions";
      }

      return $error;
    }
    
    $srTmpFolder = $ENV{SURFREPORT_OUT} . "tmp/";
    $tmpFile = $srTmpFolder . "properties.tmp";

    if (!open (OUT, ">$tmpFile"))
    {
	close IN;
       
	$error = "Can't create safety file $tmpFile: $!\n";
	   
	    
	if (! -w $srTmpFolder || ! -r $srTmpFolder || ! -x $srTmpFolder)
	{
	    $error .= "SurfReport's folder for temporary items '$srTmpFolder' ";
	    $error .= "must have WEB read/write/execute permissions\n";
	}
	
	    
	return $error;

    }

    while ($line = <IN>)
    {
	if ($line =~ /^\s*(\w+)\s*=\s*([^\n#]*)/ )
	{
	    $key = $1;
       
	    if (defined ($Form{"PROPERTY_$key"}))
	    {
		$val = $Form{"PROPERTY_$key"};
		if ($platform eq "OS_NT")
    	{
			# impose unix style slashes
			$val =~ s/\\/\//g;
    	}

		if ($key eq "filter")
		{
			# remove leading slash on filters
			# SR looks at this filter after its done some aliasing
		    if ($val =~ /^\/+/)
		    {
			$val = $';
		    }
		}
		elsif ($key eq "compress")
		{
		    if ($val =~ /compress$/ || $val =~ /gzip$/)
		    {
			$val = $`;
		    }

		    if ($val ne "" && $val !~ /\/$/)
		    {
			$val .= "/";
		    }
		}
		if ($key eq "docroot")
		{
		    if ($val !~ /\/$/)
		    {
			$val .= "/";
		    }
		}
		$line = $key . "=" . $val . "\n";
            } 
	    else
	    {
		$val = $2;
	    }
	    $Properties{$key} = $val;
        
	}	
        print OUT $line;
    }
        
    close (IN);
    close (OUT);
    if (rename ($tmpFile, $inFile) == 0)
    {
	$error = "Can't rename '$tmpFile' into '$inFile'. $!";
	return $error;
    }
    chmod 0666, $filename;

    return "";
}



sub GetConfigVars
{

    local ($filename, *Vars) = @_;
    local ( $line);
    local ($val, $out);

    
    if (!open (IN, "$filename"))
    {
      $error = "Can't open $filename: $!\n"; 
      if (!-e $filename)
      {
	 $error .=  "This configuration file is not in your configuration folder\n";
      }
      elsif (!-r $filename || !-w $filename)
      {
	 $error .=  "This configuration file must have WEB";
	 $error .= "read/write permissions";
      }

      return $error;
    }
    

    while ($line = <IN>)
    {
	if ($line !~ /^\s*([\$@%]{1,1}[a-zA-Z0-9]+)\s*=\s*([^;]+)(;*)/ )
	{
	    # not a line starting with a perl variable
	    next;
	}

	# variable is in $1, value in $2
	if (!defined $Vars{$1})
	{
	    # this variable not encountered yet

	    $val = $2;

	    # value extend across multiple lines (array or list)
	    while ($3 eq "")
	    {
		$line  = <IN>;
		$line =~ /(m?)([^;]+)(;*)/;
		$val .= $2;
	    }

	    # got the complete value, associate it
	    # with its variable name 

	    $Vars{$1} = $val;
	
	
	}
    }
       
    close (IN);

    return "";
}

sub ExpandVal
{
    local ($val) = @_;
    local ($before, $after, $exp);

    while ($val =~ /([\$]{1,1}\w+)/)
    {
	$before = $`;
	$after = $';

	if (defined ($Vars{$1}))
	{
	    $exp = $Vars{$1};
	}
	else
	{
	    $exp = "";
	}
	$val = $before . $exp . $after;
    }

    #catenate the string
    $val =~ s/["']{1,1}\s*\.\s*["']{1,1}//g;

    # unquote
    $val =~ s/^["']{1,1}//;
    $val =~ s/["']{1,1}$//;

    return $val;
}
	
sub AliasPath
{
    local ($path) = @_;

    if ($path =~ /invalid path/)
    {
	return "invalid path";
    }
    #replace multiple // by a single one
    $path =~ s!/+!/!g ;
    
    # replace /./ by /
    $path =~ s!/\./!/!g ;

    # replace ../
    while ($path =~ /\/[^\/]+\/..\//)
    {
	$path = $`."\/". $';
    }
    if ($path =~ /^\/?\.\.\//)
    {
	return "invalid path";
    }
    else
    {
	return $path;
    }
}

sub UpdateFormVars
{

    local ($infile, $outfile, *Vars,%RepList) = @_;
    local ($line, $s, $srFolder, $menuName);
    local ($val, $nRep, $newVal, $name, $error);
    local ($tag, $rest, $before, $leftover);
    local ($fCheck, $fFirstOption, $fOptionSelected, $selectVal);
    local ($fGotMenuTag);

    if (!open (IN, "$infile"))
    {
	$error = "Can't open $infile: $!\n"; 
	if (!-e $infile)
	{
	 $error .=  "The SurfReport Form interface must be ";
	 $error .= "in your surfreport home folder\n";
	}
	elsif ( !-r $infile || !-w $infile)
	{
	 $error .=  "The SurfReport Form interface must have WEB ";
	 $error .= "read/write permissions\n";
	 
	}

	return $error;
    }

    if ($outfile ne "")
    {
	if (!open (OUT, ">$outfile"))
	{
	    close IN;
       
	    $error = "Can't create safety file $outfile: $!\n";
	    
	    $srFolder = $ENV{SURFREPORT_OUT};
	    
	    if (! -w $srFolder || ! -r $srFolder || ! -x $srFolder)
	    {
		$error .= "SurfReport's output folder '$srFolder' ";
		$error .= "must have WEB read/write/execute permissions\n";
	    }
	
	    
	    return $error;

	}
    }

    $nRep = 0; 
    $fGotMenuTag = 0;
    $line = <IN>;

    while ($line)
    {
	if ( $line =~ /<\s*(\w+)/ )
	{	
	    $tag = $1;
	    $rest = $';
	    $before = $`;
	    
	    $name = "";
	    $type = "";
	    $val = "";
	    
	    $tag =~ tr/a-z/A-Z/;
       
	    if ($fGotMenuTag == 1 && $tag eq "A")
	    {
		# get entire tag <>
		while ($rest !~ />/)
		{
		    $rest .= <IN>;   
		}

		$rest =~ />/;
		$line = $';
		$leftover  = $`;
		
		if ($rest =~ /HREF/i)
		{
		    if (defined($RepList{MENU}))
		    {
			$val = $RepList{MENU};
			$nRep++;
		    }

		    if ($outfile ne "")
		    {
			print OUT $before;
			print OUT "<A HREF=\"$val\">";
		    }
		    $fGotMenuTag = 0;

		}
		else
		{
		    if ($outfile ne "")
		    {
			print OUT $before;
			print OUT "<$tag$rest$leftover>";
		    }
		}
	    }
	    elsif ($tag eq "DISPATCHERMENU")
	    {
		# get entire tag <>
		while ($rest !~ />/)
		{
		    $rest .= <IN>;   
		}

		$rest =~ />/;
		$line = $';
		$leftover  = $`;
		
		if ($rest =~ /MENU/i)
		{
		    if ($outfile ne "")
		    {
			print OUT $before;
			print OUT "<$tag$leftover>";
		    }
		    $fGotMenuTag = 1;

		}
	    }
	    elsif ($tag eq "FORM" )
	    {
		# get entire tag <>
		while ($rest !~ />/)
		{
		    $rest .= <IN>;   
		}

		$rest =~ />/;
		$line = $';
		$leftover  = $`;
		
		if ($rest =~ /METHOD/i)
		{
		    $name = $';
		    $leftover =~ s/$&//;
		    
		    $name =~ /\s*=\s*"?(\w+)"?/;
		    $name = $1;
		    
		    $s = $&;
		    $s =~ s/(\W)/\\$1/g;
		    $leftover =~ s/$s//;

		}

		if ($rest =~ /ACTION/i)
		{
		    
		    $val = $';
		    $leftover =~ s/$&//;
		    
		    $val =~ /\s*=\s*["']?([^"']+)["']?/;
		    $val = $1;
		    
		    $s = $&;
		    $s =~ s/(\W)/\\$1/g;
		    $leftover =~ s/$s//;
		    
		}
	    
		if (defined($RepList{ACTION}))
		{
		    $val = $RepList{ACTION};
		    $nRep++;
		}

		$leftover =~ s/^\s*/ /;
		
		$Vars{ACTION} = $val;

		if ($outfile ne "")
		{
		    print OUT $before;
		    print OUT "<$tag METHOD=$name ACTION=\"$val\"$leftover>";
		}
	    }
	    elsif ($tag eq "INPUT")
	    {
		# get entire tag <>
		while ( $rest !~ />/)
		{
		    $rest .= <IN>;
	     
		}
		
		$rest =~ />/;
		$line = $';
		$leftover = $`;
		
		if ($rest =~ /TYPE/i)
		{
		    $type = $';
		    $leftover =~ s/$&//;
		    
		    $type =~ /\s*=\s*"?(\w+)"?/;
		    $type = $1;
		    
		    $s = $&;
		    $s =~ s/(\W)/\\$1/g;
		    $leftover =~ s/$s//;
		    
		    $type =~ tr/a-z/A-Z/;	
		}
		else
		{
		    $type = "TEXT";
		    
		    if ($rest =~ / TEXT /i)
		    {
			$leftover =~ s/$&//;
		    }
		    
		}
		
		if ($rest =~ /NAME/i)
		{
		    $name = $';
		    $leftover =~ s/$&//;
		    
		    $name =~ /\s*=\s*"?(\w+)"?/;
		    $name = $1;
		    
		    $s = $&;
		    $s =~ s/(\W)/\\$1/g;
		    $leftover =~ s/$s//;
		}
		
		if ($rest =~ /VALUE/i)
		{
		    $val = $';
		    $leftover =~ s/$&//;
		    
		    $val =~ /\s*=\s*"?([^\">]*)"?/;
		    $val = $1;
		    
		    $s = $&;
		    $s =~ s/(\W)/\\$1/g;
		    $leftover =~ s/$s//;
		}
		
		if ($type eq "CHECKBOX" || $type eq "RADIO")
		{
		    if ($type eq "CHECKBOX")
		    {
			# force an 'on' value for every checkboxes
			# this value is only returned when
			# the box is checked
			$val = "on";
		    }

		    if ($rest =~ /CHECKED/i)
		    {
			$leftover =~ s/$&//;
			$fCheck = 1;
		    }
		    else
		    {
			$fCheck = 0;
		    }
		    
		}
		else
		{
		    $fCheck = 0;
		}
		
		if (($type eq "SUBMIT" || $type eq "RESET" ) && 
		    defined ($RepList{$type}))
		{
		    $name = $type;
		    $val = $RepList{$name};
		    $nRep++;
		}
		elsif (defined ($RepList{$name}))
		{
		    $newVal = $RepList{$name};

		    # dont change actual checkboxes and
		    # radio buttons values
		    # just change the checked option
		    if ($type eq "RADIO")
		    {
			if ($newVal eq $val)
			{
			    $fCheck = 1;
			}
			else
			{
			    $fCheck = 0;
			}
		    }
		    elsif ($type eq "CHECKBOX") 
		    {
			if ($newVal eq "on")
			{
			    $fCheck = 1;
			}
			else
			{
			    $fCheck = 0;
			}
		    }
		    else
		    {
			$val = $newVal; 
		    }
		    
		    $nRep++;
		}
		
		$leftover =~ s/^\s*/ /;
		
		if ($type eq "RADIO") 
		{
		    if ($fCheck == 1)
		    {
			$Vars{$name} = $val;
		    }
		}
		elsif ($type eq "CHECKBOX")
		{
		    if ($fCheck == 1)
		    {
			$Vars{$name} = "on";
		    }
		    else
		    {
			$Vars{$name} = "off";
		    }
		}
		else
		{
		    $Vars{$name} = $val;
		}
		
		if ($outfile ne "")
		{
		    
		    print OUT $before;
		    print OUT "<$tag TYPE=$type";
		    print OUT $name ne "" ? " NAME=\"$name\"" : "";
		    print OUT " VALUE=\"$val\"";
		    print OUT $fCheck == 1 ? " CHECKED" : "";
		    print OUT $leftover, ">";
		}
		
	    }
	    elsif ($tag eq "TEXTAREA")
	    {  
		# get entire tag <>
		while ( $rest !~ />/)
		{
		    $rest .= <IN>;
		    
		}
		
		$rest =~ />/;
		$line = $';
		$leftover = $`;
		
		if ($rest =~ /NAME/i)
		{
		    $name = $';
		    $leftover =~ s/$&//;
		    
		    $name =~ /\s*=\s*"?(\w+)"?/;
		    $name = $1;
		    
		    $s = $&;
		    $s =~ s/(\W)/\\$1/g;
		    $leftover =~ s/$s//;
		    
		}
		
		
		#get value
		$rest = $line;
		while ( $rest !~ /<\/TEXTAREA/i)
		{
		    $rest .= <IN>;
		    
		}

		$rest =~ /<\/TEXTAREA/i;
		$val = $`;
		$line = $';
		
		# replace all separators (commas and spaces)
		# by a comma and a single space
		if ($val =~ /[^\s,]+/)
		{
		    $val =~ s/[,\s]+/, /g;
		    $val =~ s/^ *//;
		    $val =~ s/ *$//;
		}
		else 
		{
		    $val = "";
		}
		
		if (defined ($RepList{$name}))
		{
		    $val = $RepList{$name};
		    $nRep++;
		}
		
		$leftover =~ s/\s*/ /;
		
		$Vars{$name} = $val;
		
		if ($outfile ne "")
		{
		    print OUT $before;
		    print OUT "<$tag NAME=\"$name\"";
		    print OUT $leftover;
		    print OUT ">$val</$tag";
		}
	    }
	    elsif ($tag eq "SELECT" )
	    {  
		# get entire tag <>
		
		while ( $rest !~ />/)
		{
		    $rest .= <IN>;
		}
		
		$rest =~ />/;
		$line = $';
		$leftover = $`;
		
		if ($rest =~ /NAME/i)
		{
		    $name = $';
		    $leftover =~ s/$&//;
		    
		    $name =~ /\s*=\s*"?(\w+)"?/;
		    $name = $1;
		    
		    $s = $&;
		    $s =~ s/(\W)/\\$1/g;
		    $leftover =~ s/$s//;
		}
		
		$leftover =~ s/\s*/ /;
		
		if (defined ($RepList{$name}))
		{
		    $selectVal = $RepList{$name};
		}
		else
		{
		    $selectVal = "";
		}
		
		$menuName = $name;
		$fFirstOption = 1;

		if ($outfile ne "")
		{
		    print OUT $before;
		    print OUT "<$tag NAME=\"$name\"$leftover>";
		}
		
	    }
	    elsif ($tag eq "OPTION" )
	    {  
		# get entire tag <>
		
		while ( $rest !~ />/)
		{
		    $rest .= <IN>;
		}
		
		$rest =~ />/;
		$line = $';
		$leftover = $`;
		
		if ($rest =~ /VALUE/i)
		{
		    $val = $';
		    $leftover =~ s/$&//;
		    
		    $val =~ /\s*=\s*"?(\w+)"?/;
		    $val = $1;
		    
		    $s = $&;
		    $s =~ s/(\W)/\\$1/g;
		    $leftover =~ s/$s//;
		    
		}
				 
		if ($rest =~ /SELECTED/i)
		{
		    $leftover =~ s/$&//;
		    $fOptionSelected = 1;    
		}
		else
		{
		    $fOptionSelected = 0;
		}
		
		$leftover =~  s/\s*/ /;
		
		if ($selectVal ne "") 
		{
		    if ($selectVal eq $val)
		    {
			$fOptionSelected = 1;
		    }
		    else
		    {
			$fOptionSelected = 0;
		    }
		}

		if ($fFirstOption == 1)
		{
		    $fFirstOption = 0;

		    # save the first option in case there is no
		    # selected option
		    $Vars{$menuName} = $val;
		}
		elsif ($fOptionSelected)
		{
		    # this will override the above
		    $Vars{$menuName} = $val;
		}
				
		if ($outfile ne "")
		{
		    print OUT $before;
		    print OUT "<$tag";
		    print OUT $fOptionSelected == 1 ? " SELECTED" : "";
		    print OUT $val != 0 ? " VALUE=\"$val\"" : "";
		    print OUT $leftover, ">";
		}
	    }
	    else
	    {	
		if ($outfile ne "")
		{
		    print OUT $before."<$tag";
		}
		$line = $rest;
	    }
	
	}
	else
	{
	    
	    if ($outfile ne "")
	    {
		print OUT $line;
	    }
	    $line = <IN>;
	}
    }
    
    close (IN);
    if ($outfile ne "")
    {
       close (OUT);

       chmod 0666, $outfile;

       #DEBUG
       $n = 0;
       while (-z $outfile && $n < 5)
       {
	   sleep(1);
	   $n++;
       }
       if ($n == 5)
       {
	   $error = "Time out waiting for $outfile\nUnable to update $infile\n";
       }
       else
       {
	   $error = "";
       }
   }
   else
   {
       $error = "";
   }

    return $error;
}

sub FatalError
{
    local ($err) = @_;

    print "<body BGCOLOR = #FFFFFF TEXT = #OOOOOO >\n";
    print "<H3>Configuration Error</H3>\n";
    

    print "<pre>\n\n";
    print $err;
    print "\n\n</pre>";

    print "<A HREF=\"$this\">[Back to Configuration]</a>\n";

    &PrintHTMLEnd();
}
  
sub GetAliases
{
    local ($aliasStr, *Aliases) = @_;
    local (@alias, $alias, $key, $val);

    #get rid of commented out lines
    $aliasStr =~ s/\s*#.*\n//g;
    #get rid of newlines
    $aliasStr =~ s/\n+/ /g;
    
    # keep text in paren
    $aliasStr =~ s/\(\s*([^\)]*).*$/$1/;
    @alias = split (/,/, $aliasStr);
    $nAlias = 0;

    for ($n = $[; $n <= $#alias; $n += 2)
    {
	$alias = $alias[$n];
	$alias =~ /^\s*[\"\']{1,1}([^\"\']+)/;
	$key = $1;

	# extra comma or unbalanced aliases
	last if ($n >= $#alias);

	$alias = $alias[$n + 1];
	$alias =~ /^\s*[\"\']{1,1}([^\"\']+)/;
	$val = $1;

	$Aliases{$key} = $val;
	$nAlias++;
       
    }
    return $nAlias;

}

sub GetListValue
{
    local ($listStr, *List) = @_;

    #get rid of commented out lines
    $listStr =~ s/\s*#.*\n//g;
    #get rid of newlines
    $listStr =~ s/\n+/ /g;    
    #get rid of quotes
    $listStr =~ s/[\"\']//g;    

    # keep text in paren
    $listStr =~ s/\(\s*([^\)]*).*$/$1/;
    @List = split (/\s*,\s*/, $listStr);
    
    return $#List + 1;

}

sub GetListStr
{
    local (@list) = @_;

    return join (', ', @list);
}

sub GetListPerlStr
{
    local (@list) = @_;
    local ($list, $i);

    $list = "(";
    $i = $[;

    foreach $item (@list)
    {
	$list .= "\"";
	$list .= $item;
	$list .= "\"";
	if ($i < $#list)
	{
	    $list .= ",";
	}
	$i++;
    }
	
    $list .= ")";

    return $list;
}

sub DisplayAliases
{
    local ($n, %Aliases, $leadStr) = @_;
    local ($htmlBuf, $key);
    
 
    $htmlBuf = "";
    
    foreach $key (sort keys (%Aliases))
    {
	$htmlBuf .= $leadStr;
	$htmlBuf .= &FormInputTag( "checkbox", "alias$n", "on", 1);
	$htmlBuf .= "  ";
	$htmlBuf .= &FormTextTag ("aliasKey$n", $key, 27);
	$htmlBuf .= " -> ";
	$htmlBuf .= &FormTextTag ("aliasVal$n", $Aliases{$key}, 27);
	$htmlBuf .= "\n\n";
	$n++;
    }
    return $htmlBuf;
}

sub DisplayEmptyAliases
{
    local ($n, $howMany, $leadStr) = @_;
    local ($htmlBuf, $key);
    
    $htmlBuf = "";
    
    while ($howMany--)
    {
	$htmlBuf .= $leadStr;
	$htmlBuf .= &FormInputTag( "checkbox", "alias$n", "on", 0);
	$htmlBuf .= "  ";
	$htmlBuf .= &FormTextTag ("aliasKey$n", "", 27);
	$htmlBuf .= " -> ";
	$htmlBuf .= &FormTextTag ("aliasVal$n", "", 27);
	$htmlBuf .= "\n\n";
	$n++;
    }
   return  $htmlBuf;
}
 
sub GetLinks
{
    local ($dir, $nlink) = @_;
    local ($dev, $ino, $mode);
	       

    ($dev, $ino, $mode, $nlink) = stat ('.') unless $nlink;
    
    opendir (DIR, '.') ||  return;
    local (@filenames) = readdir(DIR);
    closedir (DIR);
    
    
    if ($nlink == 2)
    {
	for (@filenames)
	{
	    next if $_ eq '.';
	    next if $_ eq '..';
	
	    next if (! -l $_);
	    $real = readlink ($_);
	    if (-d $real)
	    {
		$real .= "/";
		$_ .= "/";
	    }
	    if (!defined ($Aliases{$_}))
	    {
		$ServerAliases{$_} = $real;
		$numServerAlias++;
	    }
	}
    }
    else
    {
	for (@filenames)
	{
	    next if $_ eq '.';
	    next if $_ eq '..';
	    $name = "$dir/$_";

	    ($dev, $ino, $mode, $nlink) = lstat ($_);
	    if (-d _)
	    {
		next unless chdir $_;
		&GetLinks ($name, $nlink);
		chdir '..';
	    }
	    
	    elsif (-l _)
	    {
		$real = readlink($_);
		if (-d $real)
		{
		    $real .= "/";
		    $_ .= "/";
		}
		if (!defined ($Aliases{$_}))
		{
		    $ServerAliases{$_} = $real;
		    $numServerAlias++;
		}
	    }
	}
    }
}

#
# separate an address into its components
# the last component indicates an IP (1)
# or a host name (0)
#
sub SplitAddress
{
    local ($address) = @_;
    local (@parts, $len, $pos, $part, $isIP);

    $offset = $[;
    $isIP = 1;

    while (($pos = index ($address, ".", $offset)) != $[-1)
    {
	$part = substr ($address, $offset, $pos - $offset);
	if (int ($part) == 0 && $part ne "0")
	{
	    $isIP = 0;
	}
	    
	$offset = $pos+1;
	$parts[$#parts+1] = $part;
    }

    $part = substr ($address, $offset);
    if (int ($part) == 0 && $part ne "0")
    {
	$isIP = 0;
    }
    
    $parts[$#parts+1] = $part;

    $parts[$#parts+1] = $isIP;

    return @parts;

}

sub GetCompressHome
{
    # make up a list of commands to look for
    local (*exe) = @_;

    local (@cmd, @absDirs, $dir, $cmd);

    $cmd[0] = 'gunzip';
    $cmd[1] = 'uncompress';
    
    # get directories in path env
    @absDirs = reverse grep(m!^/!, split(/:/, $ENV{'PATH'}, 999));

    # look for commands in PATH
    %exe = ();
    foreach $dir (@absDirs)
    {
	foreach $cmd (@cmd)
	{
	    if (-x "$dir/$cmd")
	    {
		$exe{$cmd} = "$dir/$cmd";
		
	    }
	}
    }
}

#END















